package jp.nrttkr.audiotracksample;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.media.AudioFormat;
import android.media.AudioManager;
import android.media.AudioTrack;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class AudioTrackView extends SurfaceView
				implements SurfaceHolder.Callback,Runnable,
				AudioTrack.OnPlaybackPositionUpdateListener {
	Paint paintText;
	Thread  thread;

	float touchX;
	float touchY;

	Bitmap  bitmapMascot;
	float[] bitmapX;
	float[] bitmapY;
	float[] bitmapAngle;
	float[] bitmapScale;
	int     bitmapCounter;

	AudioTrack audioTrack;          //AudioTrack
	int        audioBufferSize;     //TEhEobt@̃TCY(oCg)
	short[]    audioData;           //TEhEf[^

	final static int SAMPLERATE = 44100;    //TEhEobt@̃TvOg
	float audioFrequency;     //݂̎g
	float audioFrequencyNext; //ڕW̎g
	float audioPhase;         //ʑ
	float audioVolume;        //݂̉
	float audioVolumeNext;    //ڕW̉

	public AudioTrackView(Context context) {
		super(context);
		// TODO Auto-generated constructor stub

		//Surface̐ݒ
		getHolder().addCallback(this);
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub

		//`惋[v
		while (thread != null) {

			//`悷摜̊pxETCYω
			int count = bitmapX.length;
			for (int i=0; i<count; ++i) {
				bitmapAngle[i] += 2.5f;
				bitmapScale[i] *= 1.02f;
			}
			++bitmapCounter;
			if (bitmapCounter > 10) {
				for (int i=1; i<count; ++i) {
					bitmapX[i-1] = bitmapX[i];
					bitmapY[i-1] = bitmapY[i];
					bitmapAngle[i-1] = bitmapAngle[i];
					bitmapScale[i-1] = bitmapScale[i];
				}
				count = count - 1;
				if (audioVolumeNext > 0.0f) {
					bitmapX[count] = touchX;
					bitmapY[count] = touchY;
					bitmapAngle[count] = 0.0f;
					bitmapScale[count] = 0.5f;
				}
				else {
					bitmapScale[count] = 0.0f;
				}
				bitmapCounter = 0;
			}

			//ʕ`
			doDraw();

			//10msҋ@
			try {
				Thread.sleep(10);
			} catch (Exception e) {
			}
		}
	}

	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		// TODO Auto-generated method stub

		//TEhݒ
		audioFrequency     = 0.0f;  //݂̎g
		audioFrequencyNext = 0.0f;  //ڕW̎g
		audioPhase         = 0.0f;  //ʑ
		audioVolume        = 0.0f;  //݂̉
		audioVolumeNext    = 0.0f;  //ڕW̉

		//TEhEobt@̍ŏTCY(Xg[~OE[h)
        int minbuffersize = AudioTrack.getMinBufferSize(
        						 SAMPLERATE,
                                 AudioFormat.CHANNEL_OUT_MONO,
                                 AudioFormat.ENCODING_PCM_16BIT);
        //mۂobt@ETCY(0.1b)
        audioBufferSize = (SAMPLERATE * 1 * 2) / 10;
        //mۂobt@ETCY(oCg)
        if (audioBufferSize < minbuffersize)
        	audioBufferSize = minbuffersize;

        //uAudioTrackv̐
        audioTrack = new AudioTrack(
                AudioManager.STREAM_MUSIC,
                SAMPLERATE,
                AudioFormat.CHANNEL_OUT_MONO,
                AudioFormat.ENCODING_PCM_16BIT,
                audioBufferSize,
                AudioTrack.MODE_STREAM);

        //uXi[v̐ݒ
        audioTrack.setPlaybackPositionUpdateListener(this);

		//TEhEf[^pz̗p
        int arraysize = audioBufferSize / 2;
		audioData = new short[arraysize];

        //u}[J[v̐ݒ
        audioTrack.setNotificationMarkerPosition(audioData.length);

        //ĐJn
        audioTrack.play();

        //ĐJn邽߁Aobt@𖞂
    	audioTrack.write(audioData, 0, audioData.length);

        //摜̕`ʒȕݒ
    	bitmapX = new float[5];
    	bitmapY = new float[5];
    	bitmapAngle = new float[5];
    	bitmapScale = new float[5];

    	//eLXg`ݒ
    	paintText = new Paint();
    	paintText.setColor(Color.WHITE);
    	paintText.setTextSize(24.0f);
    	paintText.setTypeface(Typeface.MONOSPACE);

    	// 摜ǂݍ(res/drawable-nodpi/mascot.png)
        Resources res = getContext().getResources();
        bitmapMascot = BitmapFactory.decodeResource(res, R.drawable.mascot);

        //Xbhݒ
        thread = new Thread(this);
        thread.start();
	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		// TODO Auto-generated method stub

	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		// TODO Auto-generated method stub

		//TEh~
		audioTrack.stop();
//		audioTrack.setPlaybackPositionUpdateListener(null);
		audioTrack.release();

		//XbhI
		thread = null;
	}

	@Override
	public boolean onTouchEvent (MotionEvent event) {
		touchX = event.getX();
		touchY = event.getY();
		int touchAction = event.getAction();
		int mode   = touchAction & MotionEvent.ACTION_MASK;
//		int number = touchAction >> MotionEvent.ACTION_POINTER_ID_SHIFT;

		//^b`Ăʒu̎g(C3`C6)
		float f_min = 2.11665024167469803614235361715f;   // C3 (130.8128Hz)
		float f_max = 3.0197401871670232116335923185714f; // C6 (1046.5023Hz)
		float y = 1.0f - touchY / getHeight();
		y = f_min + (f_max -f_min) * y;
		float freq = (float) Math.pow(10.0, y);

		//^b`Ăʒũ{[(0.25`0.75)
		float volu = 0.25f + (touchX / getWidth()) * 0.5f;

		if(mode != 1) {
			//^b`Jn܂̓^b`
			audioFrequencyNext = freq;
			audioVolumeNext    = volu;
		}
		else {
			//^b`I
			audioVolumeNext    = 0.0f;
		}

		//\bhŃCxg
		return true;
	}

	void doDraw() {
		//SurfaceHolder̎擾
		SurfaceHolder holder = getHolder();

		//LoXւ̕`Jn
        Canvas canvas = holder.lockCanvas();
        if (canvas == null) return;

        //wiuv
        canvas.drawColor(Color.BLUE);

        //`
        canvas.drawText("Freq=" + audioFrequency, 0, 30, paintText);
        canvas.drawText("Vol =" + audioVolume,    0, 60, paintText);

        //摜\
        Matrix mat = new Matrix();
        for (int i=0; i<bitmapX.length; ++i) {
        	if (bitmapScale[i] <= 0.0f)
        		continue;
        	mat.reset();
            mat.postRotate(bitmapAngle[i], 64, 64);
            mat.postTranslate(bitmapX[i] - 64.0f, bitmapY[i] - 64.0f);
            mat.postScale(bitmapScale[i], bitmapScale[i], bitmapX[i], bitmapY[i]);
            canvas.drawBitmap(bitmapMascot, mat, null);
        }

        //LoXւ̕`I
        holder.unlockCanvasAndPost(canvas);
	}

	@Override
	public void onMarkerReached(AudioTrack track) {
		// TODO Auto-generated method stub

		//}[J[Đݒu
        audioTrack.setNotificationMarkerPosition(audioData.length / 2);
		//̃TEhEf[^vZ
		audioNext(audioData);
		//TEhEf[^̍Đw
		track.write(audioData, 0, audioData.length);
	}

	@Override
	public void onPeriodicNotification(AudioTrack track) {
		// TODO Auto-generated method stub

	}

	void audioNext(short[] data) {
		float freqDeltaMin = audioFrequencyNext * 0.01f;
		float phaseDelta = (float)Math.PI * 2.0f / SAMPLERATE;
		for (int i=0; i<data.length; ++i) {
			data[i] = (short)(Math.sin(audioPhase)
					* Math.sin(audioPhase * 2.0f) * 0.5f
					* Math.sin(audioPhase * 4.0f) * 0.25f
					* Short.MAX_VALUE * audioVolume);
			audioPhase += phaseDelta * audioFrequency;
			
			//g̕ω
			float freqDelta = (audioFrequencyNext - audioFrequency) * 0.01f;
			if ((-freqDeltaMin < freqDelta) && (freqDelta < freqDeltaMin))
				audioFrequency = audioFrequencyNext;
			else
				audioFrequency += freqDelta;
			
			//{[̕ω
			if (audioVolume < audioVolumeNext)
				audioVolume += Math.min(audioVolumeNext - audioVolume, 0.00001f);
			else 
				audioVolume += Math.max(audioVolumeNext - audioVolume, -0.00001f);
		}
		//ʑ͈̔͂𒲐
		audioPhase = (float) Math.IEEEremainder(audioPhase, Math.PI * 2.0f);
	}
}
