package jp.nrttkr.eventsample;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.util.Log;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class EventView extends SurfaceView implements SurfaceHolder.Callback {
	Paint paintText;
	int viewWidth;
	int viewHeight;
	float[] touchPoint;
	int touchAction;

	public EventView(Context context) {
		super(context);
		// TODO Auto-generated constructor stub

		//Surface̐ݒ
		getHolder().addCallback(this);
	}

	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		// TODO Auto-generated method stub

		//`ݒ(`FuvÁuvAtHgETCYu48vAA`EGCAXuv)
		paintText = new Paint();
        paintText.setARGB(255, 255, 255, 255);
        paintText.setTypeface(Typeface.SERIF);
        paintText.setTextSize(24.0f);
        paintText.setAntiAlias(true);
        //tH[JXݒ
        setFocusable(true);
        setFocusableInTouchMode(true);
	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		// TODO Auto-generated method stub

		//SurfaceTCYۑ
		viewWidth  = width;
		viewHeight = height;
		//`p\bhĂяo
		doDraw();
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean onTouchEvent (MotionEvent event) {
		//^b`Wۑ
		int count = event.getPointerCount();
		touchPoint = new float[count * 2];
		for (int i=0; i<count; ++i) {
			int id = event.getPointerId(i);
			touchPoint[i*2]     = event.getX(id);
			touchPoint[i*2 + 1] = event.getY(id);
		}
		touchAction = event.getAction();
		int mode   = touchAction & MotionEvent.ACTION_MASK;
		int number = touchAction >> MotionEvent.ACTION_POINTER_ID_SHIFT;
		//ʕ`
		doDraw();
		//Oo
		Log.d("EventSample", "onTouchEvent PointerCount=" + count +
				"mode=" + mode + " number=" + number);
		//\bhŃCxg
		return true;
	}

	@Override
	public boolean onTrackballEvent (MotionEvent event) {
		//Oo
		Log.d("EventSample", "onTrackballEvent");
		//^b`WgbN{[ɍ킹Ĉړ
		float dx = event.getX();
		float dy = event.getY();
		if (touchPoint != null) {
			for (int i=0; i<touchPoint.length; ++i) {
				touchPoint[i] += dx; ++i;
				touchPoint[i] += dy;
			}
		}
		//ʕ`
		doDraw();
		//\bhŃCxg
		return true;
	}

	@Override
	public boolean onKeyDown (int keyCode, KeyEvent event) {
		//Oo
		Log.d("EventSample", "onKeyDown keyCode=" + keyCode);

		//eNX̃\bhŃCxg
		return super.onKeyDown(keyCode, event);
	}

	@Override
	public boolean onKeyUp (int keyCode, KeyEvent event) {
		//Oo
		Log.d("EventSample", "onKeyUp keyCode=" + keyCode);
		
		//eNX̃\bhŃCxg
		return super.onKeyDown(keyCode, event);
	}

	void doDraw() {
		//SurfaceHolder̎擾
		SurfaceHolder holder = getHolder();

		//LoXւ̕`Jn
        Canvas canvas = holder.lockCanvas();
        if (canvas == null) return;

        //wiuv
        canvas.drawColor(Color.BLACK);

        //eLXg`
        if (touchPoint != null) {
        	for (int i=0; i<touchPoint.length; ++i) {
        		float x = touchPoint[i]; ++i;
        		float y = touchPoint[i];
                canvas.drawText("(" + x + "," + y + ")", x, y, paintText);        		
        	}
        }

        //LoXւ̕`I
        holder.unlockCanvasAndPost(canvas);
	}
}
