package jp.nrttkr.threadsample;

import java.util.Random;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class ThreadView extends SurfaceView implements SurfaceHolder.Callback,Runnable{
	Paint paintText;
	int viewWidth;
	int viewHeight;
	float[] touchPoint;
	int     touchAction;
	Thread  thread;
	float[] linePoint;
	float[] lineWidth;
	int[]   lineColor;
	Random  random;
	float  fps;
	long   fpsTime;
	int    fpsCount;

	public ThreadView(Context context) {
		super(context);
		// TODO Auto-generated constructor stub

		//Surface̐ݒ
		getHolder().addCallback(this);
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub

		//`惋[v
		fpsTime  = System.currentTimeMillis();
		fpsCount = 0;
		while (thread != null) {

			//FPSv
			if (fpsCount >= 100) {
				long t = System.currentTimeMillis();
				fps = 1000.0f * fpsCount / (t - fpsTime);
				fpsTime  = t;
				fpsCount = 0;
			}
			++fpsCount;

			//`悷𗐐ŕω
			for (int i=0; i<linePoint.length; ++i)
				linePoint[i] += (random.nextFloat() - 0.5f) * 10.0f;

			//ʕ`
			doDraw();

			//10msҋ@
			try {
				Thread.sleep(10);
			} catch (Exception e) {
			}
		}
	}

	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		// TODO Auto-generated method stub

		//̏
		random = new Random();

		//`悷(100{)̏
		linePoint = new float[100 * 4];
		lineWidth = new float[100];
		lineColor = new int[100 * 4];
		for (int i=0; i<lineWidth.length; ++i) {
			float x = random.nextFloat() * getWidth();
			float y = random.nextFloat() * getHeight();
			linePoint[i*4]     = x;
			linePoint[i*4 + 1] = y;
			linePoint[i*4 + 2] = x + random.nextFloat() * 32.0f;
			linePoint[i*4 + 3] = y + random.nextFloat() * 32.0f;
			lineWidth[i]       = 1.0f + random.nextFloat() * 8;
			lineColor[i*4]     = 50;
			lineColor[i*4 + 1] = random.nextInt(256);
			lineColor[i*4 + 2] = random.nextInt(256);
			lineColor[i*4 + 3] = random.nextInt(256);
		}

		//`ݒ(`FuvÁuvAtHgETCYu48vAA`EGCAXuv)
		paintText = new Paint();
        paintText.setARGB(255, 0, 0, 0);
        paintText.setTypeface(Typeface.SERIF);
        paintText.setTextSize(24.0f);
        paintText.setAntiAlias(true);

        //Xbhݒ
        thread = new Thread(this);
        thread.start();
	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		// TODO Auto-generated method stub

		//SurfaceTCYۑ
		viewWidth  = width;
		viewHeight = height;
	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		// TODO Auto-generated method stub

		//XbhI
		thread = null;
	}

	@Override
	public boolean onTouchEvent (MotionEvent event) {
		//^b`Wۑ
		int count = event.getPointerCount();
		touchPoint = new float[count * 2];
		for (int i=0; i<count; ++i) {
			int id = event.getPointerId(i);
			touchPoint[i*2]     = event.getX(id);
			touchPoint[i*2 + 1] = event.getY(id);
		}
		touchAction = event.getAction();
		//\bhŃCxg
		return true;
	}

	void doDraw() {
		//SurfaceHolder̎擾
		SurfaceHolder holder = getHolder();

		//LoXւ̕`Jn
        Canvas canvas = holder.lockCanvas();
        if (canvas == null) return;

        //wiuv
        canvas.drawColor(Color.WHITE);

        //`
        Paint paintLine = new Paint();
        for (int i=0; i<lineWidth.length; ++i) {
        	paintLine.setARGB(lineColor[i*4], lineColor[i*4+1], lineColor[i*4+2], lineColor[i*4+3]);
        	paintLine.setStrokeWidth(lineWidth[i]);
        	canvas.drawLine(linePoint[i*4], linePoint[i*4+1], linePoint[i*4+2], linePoint[i*4+3], paintLine);
        }

        //eLXg`
        if (touchPoint != null) {
        	for (int i=0; i<touchPoint.length; ++i) {
        		float x = touchPoint[i]; ++i;
        		float y = touchPoint[i];
                canvas.drawText("(" + x + "," + y + ")", x, y, paintText);        		
        	}
        }

        // FPS`
        canvas.drawText("FPS=" + fps, 30, 30, paintText);

        //LoXւ̕`I
        holder.unlockCanvasAndPost(canvas);
	}
}
